#!/usr/bin/perl -w
use strict;
use IO::Socket::INET;

my $end_tag =  "uo6p4y65jk6b54m65bvn465xcb465s46as5g46w4t65qe4yr65yi4y65o465i\n";
my $nl =       "uo6p4y65jk6b54m65bvn465xcb465s46as4g46w4t65qe4yr65yi4y65o465i\n";
my $nodisplay ="trhji65o4h6j4f7dhhyrsb546asdfbvn32k1hjko4ptyu4er8q9sad6faxcvf\n";

open(PASS, "<pass.txt");
my @passFile = <PASS>;
close(PASS);
open(MARKS, "<exam.txt");
my @marksFile = <MARKS>;
close(MARKS);

my %passwd;
my @marks;
my %marksIndex;

##---------------------------------
## Processing the password database
foreach (@passFile) {
    my $one;
    my $two;	         
    ($one, $two) = (m/^(\w+) \W+ (\w+)/x);
    $passwd{$one} = $two;
    #print $one, " -> '", $two, "'\n";
}
my $i;
my $tests;

##---------------------------------
## Processing the marks database
for ($i = 0; $i < @marksFile; $i++) {
    $_ = $marksFile[$i];
    s{^\s+}{};
    my @marksRow = split;
    $tests = @marksRow - 1;
    for (my $j = 0; $j < @marksRow - 1; $j++) {
	$marks[$i+1][$j] = $marksRow[$j + 1];
	$marks[0][$j] += $marksRow[$j + 1];
    }
    $marksIndex{$marksRow[0]} = $i+1;
    my $examCount = @marksRow - 1;
    # print $examCount, "\n";
}
for (my $j = 0; $j < $tests; $j++) {
    #printf "$marks[0][$j]\n";
    $marks[0][$j] /= $i;
}

#foreach my $elem (%passwd) { print "'$elem'";}
#foreach my $elem (@marks{"tarun"}) { print "'$elem'";}
#for(my $i = 0; $i < @marks; $i++) {
#    for(my $j = 0; $j < 4; $j++) { print "'$marks[$i][$j]'";} 
#    print "\n";
#}
#foreach my $elem (%marksIndex) { print "'$elem'";}

##---------------------------------
## Creating sockets
my $sock = new IO::Socket::INET
    (
     LocalHost     => 'localhost',
     LocalPort     => 9100,
     Proto         => 'tcp',
     Listen        => 1,
     Reuse         => 1,
     );
die "Can't create socket: $!\n" unless $sock;

$sock->autoflush(1);

print "Exam Information Server up and running... \n\n\n";
print "Waiting for input.....\n";

##---------------------------------
## Waiting for connection
while ( my $sock_handle = $sock->accept() )
{
    print "accepting connection from ", $sock_handle->peerhost(), ".";
    print $sock_handle "$end_tag";
    print $sock_handle "$nl";
    print $sock_handle "$nodisplay";
    print $sock_handle "Welcome to the test information server. Type 'help' when needed.";
    my $login;
    my $password;
    #$/ = "\n";
    my $done = "false";
    do {
	printf $sock_handle "%slogin : $end_tag", $nl;
	$login = <$sock_handle>; chop($login);
	printf "\nUser logging in = '%s'", $login;
	printf $sock_handle "password : ${nodisplay}$end_tag";
	$password = <$sock_handle>; 
	chop($password);
	#printf "\nPassword = '$password'";
	
        ##---------------------------------
        ## Checking for authentication
	if($login ne "" &&  exists($passwd{$login}) && $passwd{$login} eq $password) {
	    if(!exists($marksIndex{$login})) {
		printf $sock_handle "%sUser authenticated. But MARKS database entry not found. Logging out...%s",$nl, $nl;
	    }
	    else {
		$done = "true";
	    }
	}
	else {
	    printf $sock_handle "%sInvalid login, password combo. Try again.$nl", $nl; 
	}
    } until ($done eq "true");
    printf "\n$login Authenticated";
    printf $sock_handle "%sWelcome $login,$nl> $end_tag", $nl;
    LINE: while ( <$sock_handle> )
    {
	chomp;
        print "\n$login > $_";
	for ( $_ )
	{
	    /^QUIT$/i && do
	    {
		print $sock_handle "Bye!$end_tag" ;
		print "\n$login has left.";
		close $sock_handle;
		last LINE;
	    };
	    /^HELP$/i && do
	    {
		printf $sock_handle "Just type the number of the exam whose mark you want to find out. Type 'quit' to when done.%s> $end_tag", $nl;
		# print $sock_handle "";
		next LINE;
	    };
	    m{^\d+} && do {
		if($marks[$marksIndex{$login}][$_ - 1] ne "") {
		printf $sock_handle "Mark aquired = %s$nl", $marks[$marksIndex{$login}][$_ - 1];
		printf $sock_handle "Class Average = %s$nl", $marks[0][$_ - 1];
	    } else {
		printf $sock_handle "You did not write that exam or data not available.${nl}";
	    }
		printf $sock_handle "> $end_tag";
		next LINE;
	    };
	    printf $sock_handle "Unknown command...$nl> $end_tag";
	    
	}
    }
}
close ( $sock );
print "Exiting\n";
